package cnv.hf.widgets;

import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.drawable.ColorDrawable;
import android.graphics.drawable.Drawable;
import android.graphics.drawable.StateListDrawable;
import android.text.TextUtils;
import android.util.AttributeSet;
import android.util.Log;
import android.view.MotionEvent;
import android.view.View;
import android.widget.Button;
import cnv.hf.widgets.HFDrawableWidget.HFDrawableEffect;
import cnv.hf.widgets.HFWidgetStorage.HFButtonStorage;

public class HFButtonWidget extends HFTextItem{
	private   HFImageListWidget binderImageListWidget = null;
	protected HFDrawableWidget focusDrawable = null;
	protected HFDrawableWidget clickDrawable = null;
	protected HFDrawableWidget disableDrawable = null;	
	private int defaultColor = Color.TRANSPARENT;
	private static long backupOnClickTime = 0;
	
	public HFButtonWidget(Context context, Object widgetData) {
		super(context, widgetData);
		initButtonMembers(widgetData);
	}
	
	@Override
	protected void setHolder(Context context,Object widgetData) {
		HFButton button = new HFButton(context);
		button.setHolder(this);
		setObject(button);
	}
	//@Override
	private void initButtonMembers(Object widgetData) {
		HFButtonStorage btnData = (HFButtonStorage)widgetData;
		if(btnData != null) {
			//õͼƬʱڣѡýͼƬֲڣѡĬͼƬ
			int[] resId = {btnData.getFocusDrawable().getBitmap(),btnData.getDefaultDrawable().getBitmap()};
			setClickDrawable(convertDynamicDrawable(btnData.getClickDrawable(),resId,btnData.getRadius()));
			//ýͼƬʱڣѡõͼƬֲڣѡĬͼƬ
			int[] resIdFocus = {btnData.getClickDrawable().getBitmap(),btnData.getDefaultDrawable().getBitmap()};
			setFocusDrawable(convertDynamicDrawable(btnData.getFocusDrawable(),resIdFocus,btnData.getRadius()));
			setDisableDrawable(convertDynamicDrawable(btnData.getDisableDrawable()));
			//setAlign((short)(HFTextAlignment.eAlignment_HoriCenter | HFTextAlignment.eAlignment_VeriCenter));			
		}
	}
	@Override
	public void setDefaultDrawable(HFDrawableWidget drawable) {
		super.setDefaultDrawable(drawable);
		setStateDrawable();
	}
	/*======================================================
	: ÿؼĵ״̬ͼƬɫ
	:  
	       drawable    [in] ͼƬɫ

	ֵ: 
	======================================================*/
	public void setClickDrawable(HFDrawableWidget drawable) {
		
		//if(	(drawable == null) 
		//	|| (clickDrawable == null && drawable != null)
		//	|| (drawable != null 
		//		&& clickDrawable != null 
		//		&& (clickDrawable.getBitmap() != drawable.getBitmap() || clickDrawable.getColor() != drawable.getColor()))) {
			
			clickDrawable = drawable;
			setStateDrawable();
		//}
	}	
	public HFDrawableWidget getClickDrawable() {
		return clickDrawable;
	}
	/*======================================================
	: ÿؼĽ״̬ͼƬɫ
	:  
	       drawable    [in] ͼƬɫ

	ֵ: 
	======================================================*/
	public void setFocusDrawable(HFDrawableWidget drawable) {
		//if(	(drawable == null) 
		//		|| (focusDrawable == null && drawable != null)
		//		|| (drawable != null 
		//			&& focusDrawable != null 
		//			&& (focusDrawable.getBitmap() != drawable.getBitmap() || focusDrawable.getColor() != drawable.getColor()))) {
			
			focusDrawable = drawable;
			setStateDrawable();
		//}
	}
	public HFDrawableWidget getFocusDrawable() {
		return focusDrawable;
	}	
	/*======================================================
	: ÿؼĽֹ״̬ͼƬɫ
	:  
	       drawable    [in] ͼƬɫ

	ֵ: 
	======================================================*/
	public void setDisableDrawable(HFDrawableWidget drawable) {
		//if(	(drawable == null) 
		//		|| (disableDrawable == null && drawable != null)
		//		|| (drawable != null 
		//			&& disableDrawable != null 
		//			&& (disableDrawable.getBitmap() != drawable.getBitmap() || disableDrawable.getColor() != drawable.getColor()))) {
			
			disableDrawable = drawable;
			setStateDrawable();
		//}		
	}	
	public HFDrawableWidget getDisableDrawable() {
		return disableDrawable;
	}	
	
	/**
	 * ״̬drawable
	 * @param type
	 * @param value
	 * @return
	 * @return Drawable
	 * @author Dinghu
	 * @date 2015612 6:27:57
	 */
	private Drawable CreateStateDrawable(int type, int value) {
		if (type == HFDrawableEffect.eDrawableEffect_Color)
			return new ColorDrawable(value);
		else if (type == HFDrawableEffect.eDrawableEffect_Bitmap)
			return HFModesManager.getDrawable(value);
		return null;
	}

	@Override
	public void setStateDrawable(int normal_type, int normal_vale,
			int focus_type, int focus_vale, int click_type, int click_value,
			int enabled_type, int enabled_value) {
		HFImageListWidget imagelist = getBinderImageListWidget();
		if (imagelist != null && imagelist.getVisible() == true) {
			Drawable normald = null, focusd = null, clickd = null, disabled = null;
			normald = CreateStateDrawable(normal_type, normal_vale);
			focusd = CreateStateDrawable(focus_type, focus_vale);
			clickd = CreateStateDrawable(click_type, click_value);
			disabled = CreateStateDrawable(enabled_type, enabled_value);
			imagelist.resetStateListDrawable(normald, focusd, clickd, disabled);
			this.getObject().invalidate();
			Log.i("SL", "btn setStateDrawable");
			return;
		}
		super.setStateDrawable(normal_type, normal_vale, focus_type,
				focus_vale, click_type, click_value, enabled_type,
				enabled_value);
	}

	@Override
	public void setStateDrawable(int focus_type, int focus_vale,
			int click_type, int click_value, int enabled_type, int enabled_value) {

		HFImageListWidget imagelist = getBinderImageListWidget();
		if (imagelist != null && imagelist.getVisible() == true) {
			Drawable normald = null, focusd = null, clickd = null, disabled = null;
			HFDrawableWidget defaultDrawable = getDefaultDrawable();
			if (defaultDrawable.getEffect() == HFDrawableEffect.eDrawableEffect_Color)
				normald = new ColorDrawable(defaultDrawable.getColor());
			else if (defaultDrawable.getEffect() == HFDrawableEffect.eDrawableEffect_Bitmap)
				normald = defaultDrawable.getBitmap();
			else if(defaultDrawable.getEffect() == HFDrawableEffect.eDrawableEffect_Nothing)
				normald = new ColorDrawable(Color.TRANSPARENT);
			focusd = CreateStateDrawable(focus_type, focus_vale);
			clickd = CreateStateDrawable(click_type, click_value);
			disabled = CreateStateDrawable(enabled_type, enabled_value);
			imagelist.resetStateListDrawable(normald, focusd, clickd, disabled);
			this.getObject().invalidate();
			Log.i("SL", "btn setStateDrawable");
			return;
		}

		super.setStateDrawable(focus_type, focus_vale, click_type, click_value,
				enabled_type, enabled_value);
	}
	
	
	/*======================================================
	: ȡť״̬ͼƬ
	:  
	ֵ: ť״̬ͼƬ
	======================================================*/
	public  StateListDrawable getBackGroundListDrawable() {
		int radius = getRadius();
		StateListDrawable sd = null;
		Drawable normald = getDrawable(getDefaultDrawable(),radius);
		Drawable focusd = getDrawable(getFocusDrawable(),radius);
		Drawable clickd = getDrawable(getClickDrawable(),radius);
		Drawable disabled = getDrawable(getDisableDrawable(),radius);
		
		if(normald == null){
			normald = new ColorDrawable(Color.TRANSPARENT);
		}
		//ûñͼƬʱͼƬʱĬϱɫûͼƬʱ͸Ĭɫ
		boolean hasImgList = getBinder() > 0;
		boolean isTextEmpty = TextUtils.isEmpty(getText().toString());
		if(clickd == null){
			clickd = normald;
		}
		//ûñͼƬʱͼƬʱ͸ûͼƬʱ͸Ĭɫ
		if(focusd == null){
			focusd = clickd;
		}
		
		if(!(normald == null || focusd == null || clickd == null )) {
			sd = new StateListDrawable();   
			sd.addState(new int[]{android.R.attr.state_focused}, focusd);  
			sd.addState(new int[]{android.R.attr.state_pressed}, clickd); 
			if(!hasImgList)
			    sd.addState(new int[]{android.R.attr.state_selected}, focusd); 
			
			if(disabled != null) {
				sd.addState(new int[]{-android.R.attr.state_enabled}, disabled);
			}
			sd.addState(new int[]{android.R.attr.state_enabled}, normald);  
		}
    	return sd;	
	}
	/*======================================================
	: ȡť״̬ͼƬ
	:  
	ֵ: ť״̬ͼƬ
	======================================================*/
	public  StateListDrawable getBackGroundListDrawable(int defaultColor) {
		int radius = getRadius();
		StateListDrawable sd = null;		
		Drawable normald = null;
		if(defaultColor == -1){
			normald = getDrawable(getDefaultDrawable(),radius);
		}else{
			normald = new ColorDrawable(defaultColor);	
		}
		
		Drawable focusd = getDrawable(getFocusDrawable(),radius);
		Drawable clickd = getDrawable(getClickDrawable(),radius);
		Drawable disabled = getDrawable(getDisableDrawable(),radius);
		
		if(normald == null){
			normald = new ColorDrawable(Color.TRANSPARENT);
		}
		boolean hasImgList = getBinder() > 0;
		if(clickd == null){
			clickd = normald;
		}

		//ûñͼƬʱͼƬʱ͸ûͼƬʱ͸Ĭɫ
		if(focusd == null){
			focusd = clickd;
		}
		if(!(normald == null || focusd == null || clickd == null )) {
			sd = new StateListDrawable(); 
			sd.addState(new int[]{android.R.attr.state_focused}, focusd);  
			sd.addState(new int[]{android.R.attr.state_pressed}, clickd); 
			if(!hasImgList)
			    sd.addState(new int[]{android.R.attr.state_selected}, focusd); 
			if(disabled != null) {
				sd.addState(new int[]{-android.R.attr.state_enabled}, disabled);
			}
			sd.addState(new int[]{android.R.attr.state_enabled}, normald);  
		}
    	return sd;	
	}
	/*======================================================
	: ðť״̬ͼƬ
	:   btnStatus [in] ť״̬
	        drawable  [in] ͼƬ
	ֵ: ť״̬ͼƬ
	======================================================*/
    private void setStateDrawable() {
    	StateListDrawable sd = getBackGroundListDrawable();
    	if(sd != null) {
   
    		getObject().setBackgroundDrawable(sd);
    	}
		return ;
    } 
    
    /*======================================================
	: ðť״̬ͼƬ
	:   btnStatus [in] ť״̬
	        drawable  [in] ͼƬ
	ֵ: ť״̬ͼƬ
	======================================================*/
    public void setOnClickListener(View.OnClickListener listener) {
    	getObject().setOnClickListener(listener);
    }
    
    /*======================================================
	: ȡImageListWidget
	:   
	ֵ:
	======================================================*/
	public HFImageListWidget getBinderImageListWidget() {
		return binderImageListWidget;
	}

	public void setBinderImageListWidget(HFImageListWidget binderImageListWidget) {
		this.binderImageListWidget = binderImageListWidget;
	}

	//HFButton
	protected static Button mPressButton = null;
    protected class HFButton extends Button {
    	private HFButtonWidget mHolder = null;
    	
        public HFButton(Context context, AttributeSet attrs, int defStyle) {  
            super(context, attrs, defStyle);  
        }  
        public HFButton(Context context, AttributeSet attrs) {  
            super(context, attrs);  
        }  
        public HFButton(Context context) {  
            super(context);  
        }
        
    	public boolean onTouchEvent (MotionEvent event) {
    	  int actionCode = event.getAction() & MotionEvent.ACTION_MASK;
    	  long timeInterval = getOnClickTimeInterval();
		  if(timeInterval <= 0)
				timeInterval = HFModesManager.getOnClickTimeInterval();
    	  if(mPressButton != null && mPressButton != this)
    		  return true;
    	  if(mPressButton == null && Math.abs(System.currentTimeMillis() - backupOnClickTime) < timeInterval){
    		  return true;
    	  }
    	  if(actionCode == MotionEvent.ACTION_DOWN){
    	     mPressButton = this;
    	  }
    	  if(actionCode == MotionEvent.ACTION_UP){
    		  backupOnClickTime = System.currentTimeMillis();
    		  mPressButton = null;
    	  }
    	  return  super.onTouchEvent(event);
    	}
        @Override
        protected void onDraw(Canvas canvas) {
            super.onDraw(canvas);
    		if(mHolder.getBinder() > 0){
    			HFImageListWidget  imagelist = mHolder.getBinderImageListWidget();
    			if(imagelist != null && imagelist.getVisible() == true){
    				Drawable d = imagelist.getImageListDrawable();
					if (null == d)
						return;
    				HFWidgetBound imgbound =imagelist.getBound();
    				HFWidgetBound btnbound = mHolder.getBound();
    				int left = imgbound.getLeft() - btnbound.getLeft();
    				int top = imgbound.getTop() - btnbound.getTop();
    				int right = left + imgbound.getWidth();
    				int bottom = top + imgbound.getHeight();
    				int[] stateset = getDrawableState();
    				d.setState(stateset);
    				d.setBounds(left, top, right, bottom);
    				canvas.save();
    				canvas.translate(this.getScrollX(),this.getScrollY());
    				d.draw(canvas);
    				canvas.restore();
    			}
    	    }
        }        
		protected HFButtonWidget getHolder() {
			return mHolder;
		}
		protected void setHolder(HFButtonWidget holder) {
			this.mHolder = holder;
		} 
    }
    /** ðťʱһͼƬ
     * @param drawable
     * @return void
     * @author LiangYJ
     * @date 2015-7-30 4:02:09
     */ 
    public void setClickCoverDrawable(Drawable res){
    	if(clickDrawable != null){
    		Drawable drawable = clickDrawable.getBitmap();
    		if(drawable != null && drawable instanceof HFDynamicDrawable){
    			HFDynamicDrawable dynamicDrawable = (HFDynamicDrawable)drawable;
    			dynamicDrawable.setClickCoverDrawable(res);
    			clickDrawable.setBitmap(dynamicDrawable);
    			setStateDrawable();
    		}
    	}
    }
    
    /** ƶͼƬλ
     * @param x
     * @param y
     * @return void
     * @author LiangYJ
     * @date 2015-9-21 6:17:59
     */ 
    public void moveImageList(int x,int y){
    	if(getBinder() > 0){
    		HFImageListWidget  imagelist = getBinderImageListWidget();
    		if(imagelist != null && imagelist.getVisible() == true){
    			Drawable d = imagelist.getImageListDrawable();
				if (null == d)
					return;
				HFWidgetBound imgbound =imagelist.getBound();
				if(imgbound != null){
					imgbound.setLeft(imgbound.getLeft() > x ? (imgbound.getLeft() - x) : 0);
					imgbound.setTop(imgbound.getTop() > y ? (imgbound.getTop() - y) : 0);
					imagelist.setBound(imgbound);
				}
    		}
    	}
    }

}
