package cnv.hf.widgets;

import android.graphics.Bitmap;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.ColorFilter;
import android.graphics.Paint;
import android.graphics.PorterDuff;
import android.graphics.PorterDuffXfermode;
import android.graphics.Rect;
import android.graphics.RectF;
import android.graphics.drawable.BitmapDrawable;
import android.graphics.drawable.Drawable;
import android.view.View;
import cnv.hf.widgets.HFModesManager.HFOnLaunchDrawableInterface;

public class HFDynamicDrawable extends Drawable {
	private int mResid = -1;
	//added by LiangYJ 20150617
//	private int mResDefaultID = -1;
	//end
	//added by LiangYJ 20150730
	private Drawable mDrawableCover;
	private int mColor = -1;//ͼƬɫЧʱͼƬĻϻɫ
	private boolean mIsDrawColor = false;//ǷҪƵɫ
	private float mRadius = 0;//ɫʱİ뾶
	//end
	private Object mPRInfo = null;
	private boolean mIsChildren = false;
	private int mDrawableType = HFDrawableType.eDrawableType_Resource;
	private HFBaseWidget mParent = null;
	private HFWidgetBound mDrawableBound = null;
	private boolean mIsFixedScale = false;//ͼƬԭп߱
	private int[] mDefaultIds;//ĬͼƬԴţֶ֧ԴļݣͨresidҲԴmDefaultIdsѭңֱҵΪֹ
	
	
	public HFDynamicDrawable(HFBaseWidget parent, int resid, boolean isChildren,HFWidgetBound mDrawBound) {
		init(parent, resid, -1, isChildren, mDrawBound);
	}
	//added by LiangYJ 20150617 residӦԴڣʹdefaultIdԴļ
	public HFDynamicDrawable(HFBaseWidget parent, int resid, int defaultId, boolean isChildren,HFWidgetBound mDrawBound) {
		init(parent, resid, defaultId, isChildren, mDrawBound);
	}
	//end
	public HFDynamicDrawable(HFBaseWidget parent, int resid, boolean isChildren,HFWidgetBound mDrawBound,boolean isFixedScale) {
		mIsFixedScale = isFixedScale;
		init(parent, resid, -1, isChildren, mDrawBound);
	}
	
	public HFDynamicDrawable(HFBaseWidget parent, int resid, int[] defaultId, boolean isChildren,HFWidgetBound mDrawBound) {
		mDefaultIds = defaultId;
		init(parent, resid, -1, isChildren, mDrawBound);
	}
	
	/** ҪƵɫ
	 * @param color
	 * @return void
	 * @author LiangYJ
	 * @date 2015-8-4 6:19:36
	 */ 
	public void setDrawColor(int color){
		mColor = color;
		mIsDrawColor = true;
	}
	
	/** Ҫɫʱİ뾶
	 * @param radius
	 * @return void
	 * @author LiangYJ
	 * @date 2015-8-4 6:20:19
	 */ 
	public void setDrawRadius(float radius){
		mRadius = radius;
	}
	
	public void setClickCoverDrawable(Drawable drawable){
		mDrawableCover = drawable;
	}
	//end
	private void init(HFBaseWidget parent, int resid, int defaultId, boolean isChildren,HFWidgetBound mDrawBound){
		mResid = resid;
//		mResDefaultID = defaultId;
		if(defaultId != -1){
			mDefaultIds = new int[1];
			mDefaultIds[0] = defaultId;
		}
		mIsChildren = isChildren;
		mParent = parent;
		initDrawableBound(isChildren,mDrawBound);
		setDrawableType(HFDrawableType.eDrawableType_Resource);
		//setPadding();
	}
	public HFDynamicDrawable(HFBaseWidget parent, Object in_pInfo, boolean isChildren,HFWidgetBound mDrawBound) {
		mPRInfo = in_pInfo;
		mIsChildren = isChildren;
		mParent = parent;
		initDrawableBound(isChildren,mDrawBound);
		setDrawableType(HFDrawableType.eDrawableType_PicSymbol);
		//setPadding();
	}
	
	private void initDrawableBound(boolean isChildren,HFWidgetBound mDrawBound){
		if(isChildren == true){
			   if(mDrawBound != null){
				   mDrawableBound = new HFWidgetBound();
				   mDrawableBound.setLeft(mDrawBound.getLeft());
				   mDrawableBound.setTop(mDrawBound.getTop());
				   mDrawableBound.setWidth(mDrawBound.getWidth());
				   mDrawableBound.setHeight(mDrawBound.getHeight());
			   }
			}
	}
	
	@Override
	public void draw(Canvas canvas) {
		if(mResid != -1 || mPRInfo != null) {
			try{
			Drawable d = getDrawable();
			if(d != null) {
				if(!mIsChildren) {
					if(mParent != null && mParent.getObject() != null) {
						//Rect rect = d.getBounds();
						View parent = mParent.getObject();
						int width = parent.getMeasuredWidth();
						int height = parent.getMeasuredHeight();
						if(width == 0 && height == 0){
							width = mParent.getBound().getWidth();
						    height = mParent.getBound().getHeight();
						}

						if(mIsFixedScale){
							//ͼƬĿ߱ͼƬ
							Rect rect = d.getBounds();
							if(rect != null){
								int imgWidth = rect.width();
								int imgHeight = rect.height();
								if(imgHeight != 0 && imgWidth != 0 && width != 0 && height != 0){
									
									float scaleImg = imgHeight * 1f / imgWidth;
									float scaleWidget = height * 1f / width;
									
									if(scaleImg > scaleWidget){
										int imgDrawWidth = (int) (height*1f / scaleImg);
										d.setBounds((width - imgDrawWidth)/2, 0, (width - imgDrawWidth)/2+imgDrawWidth, height);
									}else{
										int imgDrawHeight = (int) (width*1f * scaleImg);
										d.setBounds(0, (width - imgDrawHeight)/2, width, (width - imgDrawHeight)/2+imgDrawHeight);
									}
								}else{
									d.setBounds(0, 0, width, height);
								}
							}
						}else
						    d.setBounds(0, 0, width, height);
						
					}
					else {
						d.setBounds(getBounds());
					}
				}else{
					if(mDrawableBound != null){
					   int left = 0;
					   int top = 0;
			           if(mParent != null)
			           {
			        	   //лRadioButtonCheckBoxDrawablebound޸ģûҵ޸ĵλã
			        	   if(mParent instanceof HFSwitchWidget){
			        		   HFWidgetBound bound = ((HFSwitchWidget) mParent).getSwitchBound();
			        		   mDrawableBound.setBound(bound);
			        	   }
			        	   left = mDrawableBound.getLeft() - mParent.getBound().getLeft();
			        	   top = mDrawableBound.getTop() - mParent.getBound().getTop();
			           }
					   d.setBounds(left,top,left + mDrawableBound.getWidth(),top + mDrawableBound.getHeight());
					}
				}
	            d.draw(canvas);
 	            d.setCallback(null);

            	Rect bound = d.getBounds();

 	            
	            //added by LiangYJ 20150730,ϲ˵ͼƬɫֵ
	            if(mDrawableCover != null){
	            	mDrawableCover.setBounds(bound.left, bound.top, bound.right, bound.bottom);
	            	mDrawableCover.draw(canvas);
	            	mDrawableCover.setCallback(null);
	            }else if(mIsDrawColor){//Բǰ뾶Բǣƴɫ
	            	Paint paint = new Paint();
	            	paint.setColor(mColor);
	            	if(mRadius == 0)
	            	    canvas.drawRect(bound, paint);
	            	else{
	            		RectF rectF = new RectF();
		            	rectF.left = bound.left;
		            	rectF.top = bound.top;
		            	rectF.right = bound.right;
		            	rectF.bottom = bound.bottom;
		            	canvas.drawRoundRect(rectF, mRadius, mRadius, paint);	
		            	
//		            	canvas.drawOval(rectF, paint);
	            	}
	            	
	            }
	            //end
			}else{
				//Log.e("CLDLOGTAG","Drawable d is null");
//				System.gc();
			}
			d = null;
			}catch(Exception er){
				//Log.e("CLDLOGTAG","Drawable d is Exception");
				System.gc();
				if(mParent != null)
					mParent.getObject().postInvalidate();
			}
		}		
	}
	@Override
	public int getOpacity() {
		return 0;
	}
	@Override
	public void setAlpha(int alpha) {
	}
	@Override
	public void setColorFilter(ColorFilter cf) {
	}
	public int getResourceId() {
		return this.mResid;
	}
	//ȡDrawable
	protected Drawable getDrawable() {
		Drawable drawable = null;
		HFOnLaunchDrawableInterface launcher = HFModesManager.getOnLaunchDrawableListener();
		if(launcher != null){
			if(getDrawableType() == HFDrawableType.eDrawableType_Resource) {
				drawable = launcher.OnLaunchDrawable(mResid);	

				//added by LiangYJ 20150617
				if(drawable == null){
					if(mDefaultIds != null && mDefaultIds.length > 0){
						for (int i = 0; i < mDefaultIds.length; i++) {
							drawable = launcher.OnLaunchDrawable(mDefaultIds[i]);
							if(drawable != null)
								return drawable;
						}
					}
					
				}
				//end
			}
			else {
				drawable = launcher.OnLaunchDrawable(mPRInfo);	
			}
		}
		return drawable;
	} 
	protected void setPadding() {
		if(mParent != null && mParent.getObject() != null) {
			Drawable d = getDrawable();
			if(d != null) {
				Rect r = new Rect();
				if(d.getPadding(r)) {
					mParent.getObject().setPadding(r.left, r.top, r.right, r.bottom);
				}
			}
			d = null;
		}
	}
	protected void setPadding(Drawable drawable) {
		if(	drawable != null 
			&& mParent != null 
			&& mParent.getObject() != null) {
				Rect r = new Rect();
				if(drawable.getPadding(r)) {
					mParent.getObject().setPadding(r.left, r.top, r.right, r.bottom);
				}
		}
	}	
	public int getDrawableType() {
		return mDrawableType;
	}
	public void setDrawableType(int mDrawableType) {
		this.mDrawableType = mDrawableType;
	}
	//Drawable(װ)
	public static class HFDrawableType {
		public static final int eDrawableType_Resource  = 0x00;	//Դļ
		public static final int eDrawableType_PicSymbol = 0x01; //ӱļ
	}
}
