package cnv.hf.widgets;

import java.io.UnsupportedEncodingException;

import cnv.hf.widgets.HFWidgetStorage.HFAnimationStorage;
import cnv.hf.widgets.HFWidgetStorage.HFBaseStorage;
import cnv.hf.widgets.HFWidgetStorage.HFButtonStorage;
import cnv.hf.widgets.HFWidgetStorage.HFCheckBoxStorage;
import cnv.hf.widgets.HFWidgetStorage.HFEditStorage;
import cnv.hf.widgets.HFWidgetStorage.HFExpandableListStorage;
import cnv.hf.widgets.HFWidgetStorage.HFImageListStorage;
import cnv.hf.widgets.HFWidgetStorage.HFImageStorage;
import cnv.hf.widgets.HFWidgetStorage.HFLabelStorage;
import cnv.hf.widgets.HFWidgetStorage.HFLayerStorage;
import cnv.hf.widgets.HFWidgetStorage.HFMapStorage;
import cnv.hf.widgets.HFWidgetStorage.HFModeStorage;
import cnv.hf.widgets.HFWidgetStorage.HFPageControlStorage;
import cnv.hf.widgets.HFWidgetStorage.HFProgressStorage;
import cnv.hf.widgets.HFWidgetStorage.HFRadioButtonStorage;
import cnv.hf.widgets.HFWidgetStorage.HFSearchEditStorage;
import cnv.hf.widgets.HFWidgetStorage.HFSliderStorage;
import cnv.hf.widgets.HFWidgetStorage.HFTabBarStorage;
import cnv.hf.widgets.HFWidgetStorage.HFVarLabelStorage;
import cnv.hf.widgets.HFWidgetsManager.HFWidgetType;

public class HFJniLoader {
	
	private Object widgetData = null;
	
	public  HFJniLoader() {
		widgetData = null;
	}
	public HFBaseStorage getWidgetData() {
		return (HFBaseStorage) widgetData;
	}
	/*======================================================
	: ȡַGBK,unicodeGBKת
	:   
	      uniStrings [in]   Ҫתַ
	    
	ֵ:  תַ 
	======================================================*/	
	public byte [] getGBKBytes(String uniStrings) {
		if(uniStrings != null) {
			try {
				return uniStrings.getBytes("GBK");
			} catch (UnsupportedEncodingException e) {
				e.printStackTrace();
			}
		}
		return null;
	}
	/*======================================================
	: ģʽװģʽݵĽӿ
	:   
	    modename       [in]  ģʽ
	    
	ֵ:  ģʽݾӿڶʹáΪգʧ 
	======================================================*/
	public native long load(String modename);
	
	/*======================================================
	: ȡͼĽӿڣ
	:   
	    orientation   [in] Ļ
	    
	ֵ:  ͼ
	======================================================*/
	public native int getNumOfLayers(long pdata);
	
	/*======================================================
	: ȡĻĵĽӿ
	:   
	     	
	ֵ:  Ļ
	======================================================*/
	public native int getOrientation(long pdata);
	
	/*======================================================
	: ʺɾѷڴĽӿ
	:   
	    in_pLayout       [in]  ģʽݾɽӿcnv_hf_Mode_Load
	======================================================*/
	public native void close(long pdata);
	
	/*======================================================
	: ͼId͸õǰͼؼȡؼݵĽӿ
	:   
	    pdata       	[in]  ģʽݾɽӿcnv_hf_Mode_Load
	    layerID      	[in]  ͼID
	    pCurWidget    	[in]  ǰͼؼΪգȡͼĵһؼ
	ֵ:  ؼ
	======================================================*/
	public native long getNextWidgetData(long pdata, int layerID, long pCurWidget);
	
	/*======================================================
	: ͨȡͼݵĽӿ
	:   
	    pdata       	[in]  ģʽݾɽӿcnv_hf_Mode_Load
	    layerIndex     	[in]  ͼ
	    
	ֵ:  =0 ɹ > 0 
	======================================================*/
	private native int hfGetLayerData(long pdata, int layerIndex, Object player);
	public int getLayerData(long pdata, int layerIndex, HFLayerStorage player) {
		return hfGetLayerData(pdata, layerIndex, player);
	}
	/*======================================================
	: ȡģʽϢĽӿ
	:   
	    in_pLayout       [in]  ģʽݾɽӿcnv_hf_Mode_Load
	    
	ֵ:  =0 ɹ > 0 
	======================================================*/
	private native int hfGetModeData(long pdata, Object pmode);
	public int getModeData(long pdata, HFModeStorage pmode) {
		return hfGetModeData(pdata, pmode);
	}
	/*======================================================
	: ؼ
	: 	
		   in_eWidgetType   [in] ؼ
	       in_pWidgetData   [in] ؼʼ

	ֵ: ؼָ
	˵1󣬵ÿؼĳʼ
	       
	======================================================*/
	//public HFBaseStorage createWidgetData(int eWidgetType) {
	public Object createWidgetData(int eWidgetType) {
		switch(eWidgetType) {
		case HFWidgetType.eWidgetType_Button:
			return new HFButtonStorage();
		case HFWidgetType.eWidgetType_Label:
			return new HFLabelStorage();
		case HFWidgetType.eWidgetType_Image:
			return new HFImageStorage();
		case HFWidgetType.eWidgetType_ImageList:
			return new HFImageListStorage();
		case HFWidgetType.eWidgetType_Checkbox:
			return new HFCheckBoxStorage();	
		case HFWidgetType.eWidgetType_RadioButton:
			return new HFRadioButtonStorage();			
		case HFWidgetType.eWidgetType_Edit:
			return new HFEditStorage();	
		case HFWidgetType.eWidgetType_SearchEdit:
			return new HFSearchEditStorage();	
		case HFWidgetType.eWidgetType_Animation:
			return new HFAnimationStorage();	
		case HFWidgetType.eWidgetType_List:
			return new HFExpandableListStorage();
		case HFWidgetType.eWidgetType_Progress:
			return new HFProgressStorage();
		case HFWidgetType.eWidgetType_TabBar:
			return new HFTabBarStorage();
		case HFWidgetType.eWidgetType_MapView:
			return new HFMapStorage();
		case HFWidgetType.eWidgetType_VarLabel:
			return new HFVarLabelStorage();	
		case HFWidgetType.eWidgetType_Slider:
			return new HFSliderStorage();
		case HFWidgetType.eWidgetType_PageControl:
			return new HFPageControlStorage();
		}
		return null;
	}	
}
