package cnv.hf.widgets;

import android.annotation.SuppressLint;
import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Paint;
import android.text.SpannableString;
import android.text.Spanned;
import android.text.TextUtils;
import android.text.style.ForegroundColorSpan;
import android.util.AttributeSet;
import android.util.Log;
import android.widget.TextView;
import cnv.hf.widgets.HFTextItem.HFTextAlignment;
import cnv.hf.widgets.HFWidgetStorage.HFLabelStorage;

public class HFLabelWidget extends HFTextItem{

	private HFWidgetBorder		border;			/*߿ĿȺɫ*/	
	private int					ellipsize;		/*ʡԱ־*/		
	private int					multiLines;		/*ʾ*/			
	private int					marquee;		/*ʽ*/
	private String				keyWords;		/*ؼ*/
	private int					keyWordsColor;	/*ҪʾĹؼֵɫ*/
	  
	/*======================================================
	: Ĺ캯
	: Context 		[in] Context
	      widgetData 	[in] 	
	ֵ: 
	======================================================*/
	public HFLabelWidget(Context context, Object widgetData) {
		super(context, widgetData);
		//ʼLabel
		initLabelMembers(widgetData);
	}
	/*======================================================
	: ÿؼĳԱ
	: Context [in] Context
	ֵ: 
	======================================================*/	
	@Override
	protected void setHolder(Context context,Object widgetData) {
		MarqueeTextView tv = new MarqueeTextView(context);
		tv.setHolder(this);
		setObject(tv);
	}
	/*======================================================
	: ʼؼĺָ
	: widgetData [in] ؼ
	ֵ: ؼ
	======================================================*/
	private void initLabelMembers(Object widgetData) {

		HFLabelStorage data = (HFLabelStorage)widgetData;
		if(data != null) {
			if(data.getMultiLines() <= 0){
			    this.setEllipsize(data.getEllipsize());
			}else{
			    this.setMultiLines(data.getMultiLines());
				  // ײ벻м֮࣬ڱ߾ʱײᱻס
				  // Ĭϵıϱм࣬Եڱ߾ܾ֮ʾûо࣬ƫϣΪ룬ᱻס
//					 мΪС0.2֮Ҫıϱ߾ȥмĴС־(ֻԾжĵλ)
				this.setLineSpacing(getFont().getSize() * 1.2f);
				if((data.getAlign()& HFTextAlignment.eAlignment_VeriCenter) == HFTextAlignment.eAlignment_VeriCenter){
					TextView txt = (TextView)getObject();
					txt.setPadding(txt.getPaddingLeft(), (int) Math.round(txt.getPaddingTop() - txt.getTextSize()*0.2),
						    txt.getPaddingRight(), txt.getPaddingBottom());
				}
			}
		    

						
			HFWidgetBorder border = data.getBorder();
			if(border != null){// && border.getColor() != -1) {
				border.setColor((int)border.getColor());//convert2ARGB(border.getColor()));
			}
			this.setBorder(data.getBorder());
		}
		return ;
	}
	/*======================================================
	: ȡؼı߿
	: 
	ֵ: ߿
	======================================================*/
	public HFWidgetBorder getBorder() {
		return border;
	}
	/*======================================================
	: ÿؼı߿
	:  
	      in_pBorder [in] ߿ɫ

	ֵ: 
	======================================================*/
	public void setBorder(HFWidgetBorder border) {
		this.border = border;
		MarqueeTextView tv = (MarqueeTextView)getTextView();
		if(tv != null) {
			tv.setBorder(border);
		}	
	}
	/*======================================================
	: ȡؼĳʡ
	: 
	ֵ: ؼĳʡ
	======================================================*/
	public int getEllipsize() {
		return ellipsize;
	}
	/*======================================================
	: ÿؼĳʡ
	: 
	       in_eEllipsize    [in] ʡ
	ֵ: 
	======================================================*/
	public void setEllipsize(int ellipsize) {
		
		this.ellipsize = ellipsize;
		super.setEllipsize(ellipsize);
//		TextView tv = this.getTextView();
//		if(tv == null) {
//			return;
//		}	
//		switch(ellipsize) {
//			case Ellipsize.eEllipize_Truncate:
//				tv.setEllipsize(null);
//				break;
//			case Ellipsize.eEllipize_Start:
//				tv.setEllipsize(TextUtils.TruncateAt.valueOf("START"));
//				tv.setSingleLine();
//				break;
//			case Ellipsize.eEllipize_Middle:
//				tv.setEllipsize(TextUtils.TruncateAt.valueOf("MIDDLE"));
//				tv.setSingleLine();
//				break;
//			case Ellipsize.eEllipize_End:
//				tv.setEllipsize(TextUtils.TruncateAt.valueOf("END"));
//				tv.setSingleLine();
//				break;	
//			case Ellipsize.eEllipize_Marquee:
//				setMarquee(Marquee.eMarquee_Reciprocating);
//				break;					
//		}
	}
	/*======================================================
	: ȡؼĶ
	: 
	ֵ: ؼĶ
	======================================================*/
	public int getMultiLines() {
		return multiLines;
	}
	/*======================================================
	: ÿؼĶ
	:  in_cMutiLines    [in] 
	
	ֵ: 
	======================================================*/
	public void setMultiLines(int multiLines) {
		this.multiLines = multiLines;
		if(multiLines > 0) {
			setMultiLines(true);
			//this.getTextView().setMaxLines(128);;
		} else {
			setMultiLines(false);
			//this.getTextView().setSingleLine();
		}
	}
	/*======================================================
	: ȡؼ
	: 
	ֵ: ؼ
	======================================================*/
	public int getMarquee() {
		return marquee;
	}
	/*======================================================
	: ÿؼ
	:  in_eMarquee     [in] 
	ֵ: 
	======================================================*/
	public void setMarquee(int marquee) {
		this.marquee = marquee;
		TextView tv = this.getTextView();
		if(tv != null) {		
			tv.setEllipsize(TextUtils.TruncateAt.valueOf("MARQUEE"));
			tv.setSingleLine();
			tv.setMarqueeRepeatLimit(-1);
			tv.setFocusable(true);
			//tv.setClickable(true);
			//tv.setSelected(true);
			tv.setFocusableInTouchMode(true);
		}
	}
	/*======================================================
	: ؼ
	:  
	ֵ: 
	======================================================*/
	public void startMarquee() {
		MarqueeTextView tv = (MarqueeTextView) this.getObject();
		if(tv != null) {
			tv.setFocused(true);
			setMarquee(getMarquee());
			//tv.setSelected(true);
			tv.requestFocus();
		}
	}
	/*======================================================
	: ֹͣؼ
	:  
	ֵ: 
	======================================================*/
	public void stopMarquee() {
		MarqueeTextView tv = (MarqueeTextView) this.getObject();
		if(tv != null) {
			tv.setFocused(false);
			//tv.setSelected(false);
			setEllipsize(Ellipsize.eEllipize_Truncate);
		}
	}
	/*======================================================
	: ıҪʾĹؼֺɫ
	:  
			keyWords	[in] ҪʾĹؼ
			color		[in] ҪʾĹؼɫ
	
	ֵ: 
	======================================================*/
	public void setKeyWords(String keyWords, int color) {
		this.keyWords = keyWords;
		this.keyWordsColor = color;
		setKeyWords();
	}
	/*======================================================
	: ı
	:  
		 text [in] ı
	
	ֵ: 
	˵ظķΪ˵ùؼֵĹ
	======================================================*/
	@Override
	public void setText(CharSequence text) {
		super.setText(text);
		//ùؼ
		setKeyWords();
	}
	/*======================================================
	: ıҪʾĹؼֺɫ
	:  
	
	ֵ: 
	======================================================*/
	private void setKeyWords() {
		
		String text =  getText().toString();
		String tempkeys = this.keyWords;
		if(text == null || text.length() == 0 
			|| tempkeys == null || tempkeys.length() == 0)
		{
			return ;
		}
		String subString = "";
		int index = 0, start = 0;
		SpannableString sp = new SpannableString(text);  
		
		while(index < keyWords.length()) {
			subString = keyWords.substring(index, index+1);
			start = text.indexOf(subString, start);
			if(start >= 0) {
				sp.setSpan(new ForegroundColorSpan(keyWordsColor), start, start+1, Spanned.SPAN_EXCLUSIVE_EXCLUSIVE);
			}
			index++;
		}	
		((TextView)getObject()).setText(sp);
	}
	//ʡԱ־
	public final class Ellipsize {
	
		public static final int eEllipize_Truncate		=  0;               //ض
		public static final int eEllipize_Start			=  1;			 	//ַʼʡԣֽض
		public static final int eEllipize_Middle	   	=  2;				//ַмʡ(ݲʵ)
		public static final int eEllipize_End	       	=  3;				//ַĩβʡ
		public static final int eEllipize_Marquee		=  4;               //
	} 
	//ʽ
	public final class Marquee	{
		public static final int eMarquee_LeftToRight	=  0;	 	  		//Ұѭ
		public static final int eMarquee_Reciprocating  =  1;		  		//˶(ңٴҵ)
	} 
	
	//ҪƵTextView
	@SuppressLint("WrongCall")
	public class MarqueeTextView extends TextView {

		private HFWidgetBorder mBorder = null;
		private boolean mFocused = false;
		private HFLabelWidget mHolder = null;

		public MarqueeTextView(Context context, AttributeSet attrs, int defStyle) {
			super(context, attrs, defStyle);
			setFocused(false);
		}

		public MarqueeTextView(Context context, AttributeSet attrs) {
			super(context, attrs);
			setFocused(false);
		}

		public MarqueeTextView(Context context) {
			super(context);
			setFocused(false);
		}

		// @Override
		// protected void onFocusChanged(boolean focused, int direction, Rect
		// previouslyFocusedRect) {
		// if(focused)
		// super.onFocusChanged(focused, direction, previouslyFocusedRect);
		// }
		//
		// @Override
		// public void onWindowFocusChanged(boolean focused) {
		// if(focused)
		// super.onWindowFocusChanged(focused);
		// }
		//
		// @Override
		// public boolean isFocused() {
		// return mFocused;
		// }

		protected void setFocused(boolean focused) {
			this.mFocused = focused;
		}

		/*
		 * ====================================================== : Ʊ߿ :
		 * canvas [in] 
		 * 
		 * ֵ:  ======================================================
		 */
		private void drawBorder(Canvas canvas) {
			HFWidgetBorder border = getBorder();
			if (border == null) {
				return;
			}
			int bc = border.getColor();
			int bw = border.getWidth();
			if (bc == -1 || bw <= 0) {
				return;
			}
			Paint paint = new Paint();
			paint.setColor(bc);
			paint.setStrokeWidth(bw);

			canvas.drawLine(0, bw - 1, getWidth(), bw - 1, paint);
			canvas.drawLine(bw - 1, 0, bw - 1, getHeight(), paint);
			canvas.drawLine(getWidth() - bw + 1, 0, getWidth() - bw + 1,
					getHeight(), paint);
			canvas.drawLine(0, getHeight() - bw + 1, getWidth(), getHeight()
					- bw + 1, paint);
		}

		@Override
		protected void onDraw(Canvas canvas) {
			super.onDraw(canvas);
			drawBorder(canvas);
			HFLabelWidget holder = this.getHolder();
			if (holder != null) {
				HFOnWidgetDrawInterface listener = holder.getOnDrawListener();
				if (listener != null) {
					if (listener.onDraw(holder, canvas)) {
						return;
					}
				}
			}
		}
		
		public HFLabelWidget getHolder() {
			return mHolder;
		}

		public void setHolder(HFLabelWidget holder){
			this.mHolder = holder;
		}

		public HFWidgetBorder getBorder() {
			return mBorder;
		}
		   
		public void setBorder(HFWidgetBorder border){
			this.mBorder = border;
		}
	}
	
	/** м
	 * 
	 * @return void
	 * @author LiangYJ
	 * @date 2015-9-16 3:25:08
	 */ 
	public void setLineSpacing(float lineSpace){
		MarqueeTextView tv = (MarqueeTextView)getTextView();
		if(tv != null) {
			tv.setLineSpacing((float) Math.ceil(lineSpace), 0);
		}	
	}
}
