package cnv.hf.widgets;

import hmi.mapctrls.HPMapControl;
import hmi.mapctrls.HPMapProjection;
import hmi.mapctrls.HPMapView;
import hmi.packages.HPGLRenderer;
import hmi.packages.HPGLRenderer.HPOnGLCompletedInterface;
import hmi.packages.HPMapWarper;
import hmi.packages.HPMapWarperFactory;
import hmi.packages.HPMapWarperGL;
import android.content.Context;
import android.util.Log;

public class HFMapWidget extends HFBaseWidget{
	private boolean isOnPause = false; 
	public HFMapWidget(Context context, Object widgetData) {
		super(context, widgetData);
	}
	@Override
	protected void setHolder(Context context,Object widgetData) {
		setObject(HPMapWarperFactory.getInstance(context));
	}
	/*=======================================================
	:	ˢµͼʾ
	:	
	ֵ: 
	=======================================================*/
	public void update(boolean isUpdateMap) {
		HPMapWarper mapWarper = (HPMapWarper) getObject();
		if(mapWarper != null) {
			mapWarper.update(isUpdateMap);
		}
	}
	
	public void clearUpdateEvent(){
		HPMapWarper mapWarper = (HPMapWarper) getObject();
		if(mapWarper != null) {
			mapWarper.clearUpdateEvent();
		}
	}
	
	public HPMapView getMapView() {
		HPMapWarper mapWarper = (HPMapWarper) getObject();
		if(mapWarper != null) {
			return mapWarper.getMapView();
		}
		return null;
	}
	public HPMapProjection getMapProjection() {
		HPMapWarper mapWarper = (HPMapWarper) getObject();
		if(mapWarper != null) {
			return mapWarper.getMapProjection();
		}
		return null;
	}
	public HPMapControl getMapControl() {
		HPMapWarper mapWarper = (HPMapWarper) getObject();
		if(mapWarper != null) {
			return mapWarper.getMapControl();
		}
		return null;
	}
	public void destroyThread() {
		HPMapWarper mapWarper = (HPMapWarper) getObject();
		if(mapWarper != null) {
			mapWarper.destroyThread();
		}
	}
	public void bindMapView() {
		HPMapWarper mapWarper = (HPMapWarper) getObject();
		if(mapWarper != null) {
			mapWarper.bindMapView();
		}
	}
	/*=======================================================
	:	ȫԤģʽ
	:	
	ֵ: 
	˵: ȫԤģʽ,ƶͼ;ͼӦǰ·
	=======================================================*/	
	public void showWholeRoute() {
		HFWidgetBound wb = this.getBound();
		HPMapControl mc = this.getMapControl();
		HPMapWarper mw = (HPMapWarper) this.getObject();
		if(wb != null && mc != null && mw != null) {
			//ֹƶͼ
			mw.setIsDisableEvents(true);
			mc.showWholeRoute(wb.getWidth(), wb.getHeight());
		}
	}
	/*=======================================================
	:	ȡȫԤģʽ
	:	
	ֵ: 
	˵: ͼԶָԭĲ
	=======================================================*/		
	public void cancelWholeRoute() {
		HPMapControl mc = this.getMapControl();
		HPMapWarper mw = (HPMapWarper) this.getObject();
		if(mw != null) {
			//ֹƶͼ
			mw.setIsDisableEvents(true);
		}
		if(mc != null) {
			mc.showWholeRoute(0, 0);
		}
	}
	public void onResume() {
        // Ideally a game should implement onResume() and onPause()
        // to take appropriate action when the activity looses focus
		HPMapWarper mapWarper = (HPMapWarper) getObject();
		if(mapWarper != null) {
			mapWarper.onResume();
			isOnPause = false;
		}
    }

    public void onPause() {
        // Ideally a game should implement onResume() and onPause()
        // to take appropriate action when the activity looses focus
		HPMapWarper mapWarper = (HPMapWarper) getObject();
		if(mapWarper != null) {
			mapWarper.onPause();
			isOnPause = true;
		}
    }
    public void setOnGLCompletedListener(final HPOnGLCompletedInterface listener) {
    	HPMapWarper mapWarper = (HPMapWarper) getObject();
    	if(mapWarper instanceof HPMapWarperGL) {
    		((HPMapWarperGL)mapWarper).setOnGLCompletedListener(listener); 
    	}
//    	else if(mapWarper instanceof HPMapWarperNR){
//    		((HPMapWarperNR)mapWarper).setOnGLCompletedListener(listener); 
//    	}
    }
    
    public static boolean isCancelUpdate(){
    	return HPGLRenderer.isMapUpdateInterrupt();
    }
    
    public static void setCancelUpdate(boolean cancelUpdate){
    	HPGLRenderer.setMapUpdateInterrupt(cancelUpdate);;
    }
    
	public boolean isOnPause() {
		return isOnPause;
	}
}
