package cnv.hf.widgets;

import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.ColorFilter;
import android.graphics.Paint;
import android.graphics.Paint.Style;
import android.graphics.drawable.ClipDrawable;
import android.graphics.drawable.ColorDrawable;
import android.graphics.drawable.Drawable;
import android.graphics.drawable.GradientDrawable;
import android.graphics.drawable.LayerDrawable;
import android.graphics.drawable.StateListDrawable;
import android.util.AttributeSet;
import android.view.Gravity;
import android.view.MotionEvent;
import android.view.ViewConfiguration;
import android.view.ViewParent;
import android.widget.SeekBar;
import android.widget.SeekBar.OnSeekBarChangeListener;
import cnv.hf.widgets.HFDrawableWidget.HFDrawableEffect;
import cnv.hf.widgets.HFWidgetStorage.HFButtonStorage;
import cnv.hf.widgets.HFWidgetStorage.HFDrawableStorage;
import cnv.hf.widgets.HFWidgetStorage.HFSliderStorage;

public class HFSliderWidget extends HFBaseWidget{
	private  short	style;		/**/	
	private int		minRange;			        /*СΧ*/	
	private int		maxRange;			        /*Χ*/	
	private int		position;			        /*ǰλ*/	
	private int     toppadding = 0;
	private int     bottompadding = 0;        
	private HFDrawableWidget  startDrawable;    /*ͼƬɫ*/		
	private HFDrawableWidget  endDrawable;		/*ͼƬɫ*/		
	private HFDrawableWidget  centerDrawable;	/*ͼƬɫ*/	
	private HFOnSeekBarChangeListener mOnSeekBarChangeListener;
	
	public static class HFSliderStyle{
		public static final int eSliderStyle_Horizontal = 0x00000001;   //ˮƽ
		public static final int eSliderStyle_Vertical = 0x00000002;   //ֱ
	}
	
	public HFSliderWidget(Context context, Object widgetData) {
		super(context, widgetData);
		initSliderMembers(widgetData);
	}
	@Override
	protected void setHolder(Context context,Object widgetData) {
		HFSliderStorage pData = (HFSliderStorage)widgetData;
		if(pData.getSliderStyle() == HFSliderStyle.eSliderStyle_Horizontal){
		  HFSeekBar seekbar = new HFSeekBar(context, null, android.R.attr.progressBarStyleHorizontal);
		  seekbar.setHolder(this);
		  setObject(seekbar);
		}else{
		  HFVerticalSeekBar seekbar = new HFVerticalSeekBar(context, null, android.R.attr.progressBarStyleHorizontal);
		  seekbar.setHolder(this);
		  setObject(seekbar);
		}
	}
	
	private void initSliderMembers(Object widgetData) {
		HFSliderStorage pData = (HFSliderStorage)widgetData;
		if(pData != null) {
			minRange = pData.getMinRange();
			maxRange = pData.getMaxRange();
			position = pData.getPosition();
			style = pData.getType();
			//ýķ
			setSliderStyle(pData.getSliderStyle());
			//ý
			setProgressItem(pData);
			//ýɫֵ
			setLayerDrawable();	
			//ֵ
			setMaxRange(maxRange);
			//õǰ
			setCurrentPosition(position);
			//϶Thumb
			setThumbDrawable(pData);
			//ü¼
			setOnSeekBarChangeListener();
			//Slider padding
			if(getUpOrder() >= 0 && getDownOrder() >= 0)
		      ((SeekBar)getObject()).setPadding(0,getUpOrder(), 0, getDownOrder());
			else if(getLeftOrder() >= 0 && getRightOrder() >= 0)
			  ((SeekBar)getObject()).setPadding(getLeftOrder(),0, getRightOrder(), 0);
		}
	}
	
	/*======================================================
	: ¼
	:  positon
	ֵ: 
	======================================================*/
	public void setOnSeekBarChangeListener(){
		((SeekBar)getObject()).setOnSeekBarChangeListener(new OnSeekBarChangeListener(){

			@Override
			public void onProgressChanged(SeekBar seekBar, int progress,
					boolean fromUser) {
				position = progress;
				// TODO Auto-generated method stub
				//seekBar.setProgress(progress);
				if(mOnSeekBarChangeListener != null){
					mOnSeekBarChangeListener.onProgressChanged(HFSliderWidget.this, progress, fromUser);
				}
			}

			@Override
			public void onStartTrackingTouch(SeekBar seekBar) {
				// TODO Auto-generated method stub
				if(mOnSeekBarChangeListener != null){
					mOnSeekBarChangeListener.onStartTrackingTouch(HFSliderWidget.this);
				}
			}

			@Override
			public void onStopTrackingTouch(SeekBar seekBar) {
				// TODO Auto-generated method stub
				if(mOnSeekBarChangeListener != null){
					mOnSeekBarChangeListener.onStopTrackingTouch(HFSliderWidget.this);
				}
			}
		});
	}
	
	/*======================================================
	: õǰλ
	:  positon
	ֵ: 
	======================================================*/
	public void setCurrentPosition(int positon){
		if(positon >= 0 && positon <= maxRange){
		   ((SeekBar)getObject()).setProgress(positon);
		   this.position = positon;
		}
	}
	
	/*======================================================
	: ȡǰλ
	:  
	ֵ: 
	======================================================*/
	public int getCurrentPosition(){
		return this.position;
	}
	
	/*======================================================
	: ֵ
	:  
	ֵ: 
	======================================================*/
	public void setMaxRange(int maxrange){
		if(maxrange > 0){
		((SeekBar)getObject()).setMax(maxrange);
		 maxRange = maxrange;
		}
	}
	
	/*======================================================
	: ȡֵ
	:  
	ֵ: 
	======================================================*/
	public int getMaxRange(){
		return maxRange;
	}
	
	/*======================================================
	: ý
	:  
	ֵ: 
	======================================================*/	
	private void setProgressItem(HFSliderStorage seekbarStorage) {
		if(seekbarStorage != null) {
			startDrawable = convertDrawable(seekbarStorage.getStart());
			centerDrawable = convertDrawable(seekbarStorage.getCenter());
			endDrawable = convertDrawable(seekbarStorage.getEnd());
		}
	}
	
	private ThumbDrawable createThumbDrawable(HFDrawableStorage ds,HFWidgetBound bound){
		if(ds.getEffect() != HFDrawableEffect.eDrawableEffect_Nothing){
			return new ThumbDrawable(ds,this,bound);
		}
		return null;
	}
	
	/*======================================================
	: ϶Drawable
	:  
	ֵ: 
	======================================================*/	
	private void setThumbDrawable(HFSliderStorage sliderStorage){
		
		HFButtonStorage btnData = sliderStorage.getButton();
		ThumbDrawable normald = createThumbDrawable(btnData.getDefaultDrawable(),btnData.getBound());
		ThumbDrawable focusd = createThumbDrawable(btnData.getFocusDrawable(),btnData.getBound());
		ThumbDrawable clickd = createThumbDrawable(btnData.getClickDrawable(),btnData.getBound());
		ThumbDrawable disabled = createThumbDrawable(btnData.getDisableDrawable(),btnData.getBound());
		StateListDrawable sd = null;		

		if(!(normald == null || focusd == null || clickd == null )) {
			sd = new StateListDrawable(); 
			sd.addState(new int[]{android.R.attr.state_focused}, focusd);  
			sd.addState(new int[]{android.R.attr.state_pressed}, clickd);  
			if(disabled != null) {
				sd.addState(new int[]{-android.R.attr.state_enabled}, disabled);
			}
			sd.addState(new int[]{android.R.attr.state_enabled}, normald);  
		}
		((SeekBar)getObject()).setThumb(sd);
	}
	
	/*======================================================
	: ȡǰıɫ
	: 
	ֵ: ɫ
	======================================================*/
	private int [] getBackgroundColors() {
		
		int colors[] = new int []{	Color.parseColor("#ff9d9e9d"), 
									Color.parseColor("#ff5a5d5a"), 
									Color.parseColor("#ff747674")};
		
		HFDrawableWidget drawable = getDefaultDrawable();
		if(drawable != null) {
			if((drawable.getEffect() & HFDrawableEffect.eDrawableEffect_Color) == HFDrawableEffect.eDrawableEffect_Color) {
				for(int index = 0; index < colors.length; index++) {
					colors[index] = (int)drawable.getColor();//convert2ARGB((int)drawable.getColor());
				}
			}
		}

		return colors;
	}
	
	/*======================================================
	: ȡǰɫ
	: 
	ֵ: ɫ
	======================================================*/
	private int [] getProgressColors() {
		
		int colors[] = new int []{	Color.parseColor("#80ff0000"), 
									Color.parseColor("#8000ff00"), 
									Color.parseColor("#ff747674")};
		
		if((startDrawable != null && centerDrawable != null && endDrawable != null)
			&&((startDrawable.getEffect() & HFDrawableEffect.eDrawableEffect_Color) == HFDrawableEffect.eDrawableEffect_Color)
			&&((centerDrawable.getEffect() & HFDrawableEffect.eDrawableEffect_Color) == HFDrawableEffect.eDrawableEffect_Color)
			&&((endDrawable.getEffect() & HFDrawableEffect.eDrawableEffect_Color) == HFDrawableEffect.eDrawableEffect_Color)) {

				colors[0] = (int)startDrawable.getColor();//convert2ARGB((int)startDrawable.getColor());
				colors[1] = (int)centerDrawable.getColor();//convert2ARGB((int)centerDrawable.getColor());
				colors[2] = (int)endDrawable.getColor();//convert2ARGB((int)endDrawable.getColor());
		}

		return colors;
	}	
	
	/*======================================================
	: ýֵ
	: 
	ֵ: 
	======================================================*/
	private void setLayerDrawable() {
		int padding = 0;
		LayerDrawable progressDrawable = (LayerDrawable)((SeekBar)getObject()).getProgressDrawable();
		Drawable[] outDrawables = new Drawable[progressDrawable.getNumberOfLayers()];
		if(getUpOrder()>= 0 && getDownOrder()>=0)
			padding = getUpOrder() + getDownOrder();
		else if(getLeftOrder()>=0 && getRightOrder()>=0)
			padding = getLeftOrder() + getRightOrder();
		float radiu = (getBound().getHeight() - padding)/2;
		if(style == HFSliderStyle.eSliderStyle_Vertical)
			radiu = (getBound().getWidth() - padding)/2;
		((SeekBar)getObject()).setBackgroundDrawable(null);
		for (int i = 0; i < progressDrawable.getNumberOfLayers(); i++) {

				switch (progressDrawable.getId(i)) {
		
				case android.R.id.background: {//ý 
					//outDrawables[i] = progressDrawable.getDrawable(i);
					GradientDrawable mDrawable = new GradientDrawable(GradientDrawable.Orientation.TOP_BOTTOM,
							getBackgroundColors());
					
					mDrawable.setGradientCenter(0.0f, 0.75f);
					mDrawable.setGradientRadius((float)(Math.sqrt(5) * 60)); 
					mDrawable.setGradientType(GradientDrawable.LINEAR_GRADIENT);
					mDrawable.setCornerRadii(new float[] { radiu, radiu, radiu, radiu, radiu, radiu, radiu, radiu }); 
					outDrawables[i] = mDrawable;
				}
				break;
		
				case android.R.id.secondaryProgress://ö
				{
				   //ԭעͣ6-12޸ڱһ
				   // outDrawables[i] = progressDrawable.getDrawable(i);
					GradientDrawable mDrawable = new GradientDrawable(GradientDrawable.Orientation.TOP_BOTTOM,
							getBackgroundColors());
					
					mDrawable.setGradientCenter(0.0f, 0.75f);
					mDrawable.setGradientRadius((float)(Math.sqrt(5) * 60)); 
					mDrawable.setGradientType(GradientDrawable.LINEAR_GRADIENT);
					mDrawable.setCornerRadii(new float[] { radiu, radiu, radiu, radiu, radiu, radiu, radiu, radiu }); 
					outDrawables[i] = mDrawable;
				}
				break;
		
				case android.R.id.progress: {//ý
					GradientDrawable mDrawable = new GradientDrawable(GradientDrawable.Orientation.TOP_BOTTOM,
													getProgressColors());
			
					mDrawable.setGradientCenter(0.0f, 0.75f);
					mDrawable.setGradientRadius((float)(Math.sqrt(5) * 60)); 
					mDrawable.setGradientType(GradientDrawable.LINEAR_GRADIENT);
					mDrawable.setCornerRadii(new float[] { radiu, radiu, radiu, radiu, radiu, radiu, radiu, radiu });   
					Drawable oldDrawable = progressDrawable.getDrawable(i);
			        ClipDrawable proDrawable = new ClipDrawable(mDrawable, Gravity.LEFT,ClipDrawable.HORIZONTAL);
			        proDrawable.setLevel(oldDrawable.getLevel());
			        outDrawables[i] = proDrawable;
				}
				break;
				default:
				break;
			}
		}
		progressDrawable = new LayerDrawable(outDrawables);
		((SeekBar)getObject()).setProgressDrawable(progressDrawable);
	}
	public short getSliderStyle() {
		return style;
	}
	public void setSliderStyle(short style) {
		this.style = style;
	}
	public HFOnSeekBarChangeListener getOnSeekBarChangeListener() {
		return mOnSeekBarChangeListener;
	}
	public void setOnSeekBarChangeListener(HFOnSeekBarChangeListener mOnSeekBarChangeListener) {
		this.mOnSeekBarChangeListener = mOnSeekBarChangeListener;
	}
	public class HFSeekBar extends SeekBar{
		private HFSliderWidget mHolder = null;
		public HFSeekBar(Context context) {
			super(context);
			// TODO Auto-generated constructor stub
		}
		public HFSeekBar(Context context, AttributeSet attrs) {
			super(context,attrs);
		}
		public HFSeekBar(Context context, AttributeSet attrs, int defStyle){
			super(context,attrs,defStyle);
		}
		public HFSliderWidget getHolder() {
			return mHolder;
		}
		public void setHolder(HFSliderWidget mHolder) {
			this.mHolder = mHolder;
		}
	}
	public class HFVerticalSeekBar extends SeekBar{
		private HFSliderWidget mHolder = null;
	    private boolean mIsDragging;
	    private float mTouchDownY;
	    private int mScaledTouchSlop;
	    private boolean isInScrollingContainer = false;

	    public boolean isInScrollingContainer(){
	        return isInScrollingContainer;
	    }

	    public void setInScrollingContainer(boolean isInScrollingContainer) {
	        this.isInScrollingContainer = isInScrollingContainer;
	    }

	    /**
	     * On touch, this offset plus the scaled value from the position of the
	     * touch will form the progress value. Usually 0.
	     */
	    float mTouchProgressOffset;

	    public HFVerticalSeekBar(Context context, AttributeSet attrs, int defStyle){
	        super(context, attrs, defStyle);
	        mScaledTouchSlop = ViewConfiguration.get(context).getScaledTouchSlop();
	    }

	    public HFVerticalSeekBar(Context context, AttributeSet attrs){
	        super(context, attrs);
	    }

	    public HFVerticalSeekBar(Context context){
	        super(context);
	    }

	    @Override
	    protected void onSizeChanged(int w, int h, int oldw, int oldh){
	        super.onSizeChanged(h, w, oldh, oldw);
	    }

	    @Override
	    protected synchronized void onMeasure(int widthMeasureSpec,
	            int heightMeasureSpec){
	        super.onMeasure(heightMeasureSpec, widthMeasureSpec);
	        setMeasuredDimension(getMeasuredHeight(), getMeasuredWidth());
	    }

	    @Override
	    protected synchronized void onDraw(Canvas canvas){
	        canvas.rotate(-90);
	        canvas.translate(-getHeight(), 0);
	        super.onDraw(canvas);
	    }

	    @Override
	    public boolean onTouchEvent(MotionEvent event)
	    {
	        if (!isEnabled()){
	            return false;
	        }
	        switch (event.getAction())
	        {
	            case MotionEvent.ACTION_DOWN:
	                if (isInScrollingContainer()){
	                    mTouchDownY = event.getY();
	                }
	                else {
	                    setPressed(true);
	                    invalidate();
	                    onStartTrackingTouch();
	                    trackTouchEvent(event);
	                    attemptClaimDrag();
	                    onSizeChanged(getWidth(), getHeight(), 0, 0);
	                }
	                break;

	            case MotionEvent.ACTION_MOVE:
	                if (mIsDragging) {
	                    trackTouchEvent(event);
	                }
	                else{
	                    final float y = event.getY();
	                    if (Math.abs(y - mTouchDownY) > mScaledTouchSlop)
	                    {
	                        setPressed(true);
	                        invalidate();
	                        onStartTrackingTouch();
	                        trackTouchEvent(event);
	                        attemptClaimDrag();
	                    }
	                }
	                onSizeChanged(getWidth(), getHeight(), 0, 0);
	                break;

	            case MotionEvent.ACTION_UP:
	                if (mIsDragging) {
	                    trackTouchEvent(event);
	                    onStopTrackingTouch();
	                    setPressed(false);
	                }
	                else{
	                    // Touch up when we never crossed the touch slop threshold
	                    // should
	                    // be interpreted as a tap-seek to that location.
	                    onStartTrackingTouch();
	                    trackTouchEvent(event);
	                    onStopTrackingTouch();
	                }
	                onSizeChanged(getWidth(), getHeight(), 0, 0);
	                // ProgressBar doesn't know to repaint the thumb drawable
	                // in its inactive state when the touch stops (because the
	                // value has not apparently changed)
	                invalidate();
	                break;
	        }
	        return true;
	    }

	    private void trackTouchEvent(MotionEvent event){
	        final int height = getHeight();
	        final int top = getPaddingTop();
	        final int bottom = getPaddingBottom();
	        final int available = height - top - bottom;

	        int y = (int) event.getY();
	        float scale;
	        float progress = 0;

	        // Сֵ
	        if (y > height - bottom){
	            scale = 0.0f;
	        }
	        else if (y < top){
	            scale = 1.0f;
	        }
	        else{
	            scale = (float) (available - y + top) / (float) available;
	            progress = mTouchProgressOffset;
	        }

	        final int max = getMax();
	        progress += scale * max;
	        setProgress((int) progress);
	    }

	    /**
	     * This is called when the user has started touching this widget.
	     */
	    void onStartTrackingTouch(){
	        mIsDragging = true;
	    }

	    /**
	     * This is called when the user either releases his touch or the touch is
	     * canceled.
	     */
	    void onStopTrackingTouch() {
	        mIsDragging = false;
	    }

	    private void attemptClaimDrag() {
	        ViewParent p = getParent();
	        if (p != null){
	            p.requestDisallowInterceptTouchEvent(true);
	        }
	    }

	    @Override
	    public synchronized void setProgress(int progress){
	        super.setProgress(progress);
	        onSizeChanged(getWidth(), getHeight(), 0, 0);
	    }

		public HFSliderWidget getHolder() {
			return mHolder;
		}

		public void setHolder(HFSliderWidget mHolder) {
			this.mHolder = mHolder;
		}
	}
	
	public class ThumbDrawable extends Drawable{
		private HFSliderWidget mHolder;
		private int mImageID;
		private int mColor;
		private HFWidgetBound mBound = null;
		public ThumbDrawable(HFDrawableStorage ds,HFSliderWidget mholder,HFWidgetBound bound){
			if((ds.getEffect()& HFDrawableEffect.eDrawableEffect_Bitmap) ==  HFDrawableEffect.eDrawableEffect_Bitmap) {
			   if(ds.getBitmap() > 0)
				mImageID = ds.getBitmap();
			}else{
				mColor = ds.getColor();
				mImageID = 0;
			}
			mHolder = mholder;
			mBound = bound;
		}
		@Override
		public void draw(Canvas canvas) {
			// TODO Auto-generated method stub
			int width = mHolder.getBound().getWidth();
			int max = mHolder.getMaxRange() > 0?mHolder.getMaxRange():100;
			int yoffset = mHolder.getUpOrder() > 0?mHolder.getUpOrder():0;
			if(mHolder.getSliderStyle() == HFSliderStyle.eSliderStyle_Vertical) 
				width = mHolder.getBound().getHeight();
			float cell = (float) (width*1.0/max);
			if(mImageID > 0){
				Drawable d = HFModesManager.getDrawable(mImageID);	
			    int left = (int) (cell*mHolder.getCurrentPosition() - mBound.getWidth()/2);
			    int top = 0 - yoffset;
			    left = left < 0?0:left;
			    left = left > width - mBound.getWidth()?width - mBound.getWidth():left;
			    d.setBounds(left, top, left + mBound.getWidth(), top + mBound.getHeight());
				d.draw(canvas);
			}else{
				int r = 0;
				Paint paint = new Paint();
				paint.setColor(mColor);
				paint.setStyle(Style.FILL);
				paint.setAntiAlias(true);
				r = mBound.getHeight()/2;
				int x = (int) (cell*mHolder.getCurrentPosition());
				int y = mBound.getHeight()/2;
				x = x - r < 0 ? r:x;
				x = x > width -r?width -r:x;
				canvas.drawCircle(x, y - yoffset, r, paint);
			}
		}

		@Override
		public int getOpacity() {
			// TODO Auto-generated method stub
			return 0;
		}

		@Override
		public void setAlpha(int alpha) {
			// TODO Auto-generated method stub
			
		}

		@Override
		public void setColorFilter(ColorFilter cf) {
			// TODO Auto-generated method stub
		}
	}
	
	public interface HFOnSeekBarChangeListener{
		public void onProgressChanged(HFSliderWidget seekBar, int progress,boolean fromUser);
		public void onStartTrackingTouch(HFSliderWidget seekBar);
		public void onStopTrackingTouch(HFSliderWidget seekBar);
	}
}
