package cnv.hf.widgets;

import android.content.Context;
import android.text.TextUtils;
import android.view.ViewParent;
import android.widget.AbsoluteLayout.LayoutParams;
import android.widget.TextView;

@SuppressWarnings("deprecation")
public class HFVarLabelWidget extends HFLabelWidget{

	public HFVarLabelWidget(Context context, Object widgetData) {
		super(context, widgetData);
	}
	/*=======================================================
	: ÿؼλ
	:  in_pBound  [in] ؼλ
	ֵ: 
	======================================================*/
	@Override
	public void setBound(HFWidgetBound bound) {
		if(bound != null) {
			HFWidgetBound sbound = getBound();
			if(sbound != null) {
				sbound.setBound(bound);
				sbound.setWidth(LayoutParams.WRAP_CONTENT);
				sbound.setHeight(LayoutParams.WRAP_CONTENT);
			}
			super.setBound(sbound);
		}
	}
	/*=======================================================
	: ÿؼ
	:  	x  [in] x
			y  [in] y	
	ֵ: 
	======================================================*/	
	public void setXY(int x, int y) {
		HFWidgetBound bound = new HFWidgetBound(x, 
												y, 
												LayoutParams.WRAP_CONTENT, 
												LayoutParams.WRAP_CONTENT);
		setBound(bound);
	}
	/*=======================================================
	: ȡؼĿ
	:  
	ֵ: ؼĿ
	======================================================*/		
	public int getMeasureWidth() {
		int width = 0;
		TextView tv = (TextView) getObject();
		if(tv != null) {
			width = tv.getMeasuredWidth();
			if(width <= 0) {
				if(measure()) {
					width = tv.getMeasuredWidth();
				}
			}
		}
		return width;
	}
	/*=======================================================
	: ȡؼĸ߶
	:  
	ֵ: ؼĸ߶
	======================================================*/		
	public int getMeasureHeight() {
		int height = 0;
		TextView tv = (TextView) getObject();
		if(tv != null) {
			height = tv.getMeasuredHeight();
			if(height <= 0) {
				if(measure()) {
					height = tv.getMeasuredHeight();
				}
			}
		}
		return height;
	}
	/*=======================================================
	: ÿؼMeasure
	:  
	ֵ: true ɹ
			false ʧ
	======================================================*/		
	private boolean measure() {
		TextView tv = (TextView) getObject();
		if(tv != null) {
			if(!TextUtils.isEmpty(tv.getText())) {
				//ҪMeasure
				ViewParent parent = tv.getParent();
				if(parent != null && parent instanceof HFLayerWidget) {
					HFLayerWidget layer = (HFLayerWidget) parent;
					LayoutParams params = (LayoutParams) layer.getLayoutParams();
					if(params != null) {
						tv.measure(params.width, params.height);
						return true;
					}
				}
			}
		}	
		return false;
	}
}
