package cnv.hf.widgets;

import android.content.Context;
import android.util.Log;

public class HFWidgetsManager {
	
	private Context mContext = null;
	
	public HFWidgetsManager(Context context) {
		mContext = context;
	}
	/*======================================================
	: ؼ
	: 	
		   in_eWidgetType   [in] ؼ
	       in_pWidgetData   [in] ؼʼ

	ֵ: ؼָ
	˵1󣬵ÿؼĳʼ       
	======================================================*/
	public Object createWidget(int eWidgetType, Object widgetData) {
		switch(eWidgetType) {
		case HFWidgetType.eWidgetType_Button:
			return new HFButtonWidget(mContext, widgetData);
		case HFWidgetType.eWidgetType_Label:
			return new HFLabelWidget(mContext, widgetData);
		case HFWidgetType.eWidgetType_Layer:
			if(mContext == null) {
				Log.e("CLDLOGTAG", "context is null.\n");
			}
			return new HFLayerWidget(mContext, widgetData);
		case HFWidgetType.eWidgetType_Image:
			return new HFImageWidget(mContext, widgetData);	
		case HFWidgetType.eWidgetType_ImageList:
			return new HFImageListWidget(mContext, widgetData);
		case HFWidgetType.eWidgetType_Checkbox:
			return new HFCheckBoxWidget(mContext, widgetData);
		case HFWidgetType.eWidgetType_Animation:
			return new HFAnimationWidget(mContext, widgetData);	
		case HFWidgetType.eWidgetType_List:
			return new HFExpandableListWidget(mContext, widgetData);
		case HFWidgetType.eWidgetType_RadioButton:
			return new HFRadioButtonWidget(mContext, widgetData);
		case HFWidgetType.eWidgetType_Progress:
			return new HFProgressWidget(mContext, widgetData);
		case HFWidgetType.eWidgetType_Edit:
			return new HFEditWidget(mContext, widgetData);
		case HFWidgetType.eWidgetType_TabBar:
			return new HFTabBarWidget(mContext, widgetData);
		case HFWidgetType.eWidgetType_MapView:
			return new HFMapWidget(mContext, widgetData);
		case HFWidgetType.eWidgetType_Slider:
			return new HFSliderWidget(mContext, widgetData);
		case HFWidgetType.eWidgetType_VarLabel:
			return new HFVarLabelWidget(mContext, widgetData);	
		case HFWidgetType.eWidgetType_PageControl:
			return new HFViewPagerWidget(mContext, widgetData);
		}
		return null;
	}
	//ؼ
	public class HFWidgetType	{
		public static final int eWidgetType_Nothing        = 0x00000000;    //
		public static final int eWidgetType_Button         = 0x00000001;    //ť
		public static final int eWidgetType_RadioButton    = 0x00000002;    //RadioButton
		public static final int eWidgetType_Checkbox       = 0x00000003;    //ѡ
		public static final int eWidgetType_Label          = 0x00000004;    //ǩ 
		public static final int eWidgetType_Edit           = 0x00000005;    //༭
		public static final int eWidgetType_SearchEdit     = 0x00000006;    //༭
		public static final int eWidgetType_Combox         = 0x00000007;    //Ͽ
		public static final int eWidgetType_Image          = 0x00000008;    //ͼƬ
		public static final int eWidgetType_Animation      = 0x00000009;    //
		public static final int eWidgetType_List           = 0x0000000A;    //б
		public static final int eWidgetType_Progress       = 0x0000000B;    //
		public static final int eWidgetType_ScrollView     = 0x0000000C;    //
		public static final int eWidgetType_TabBar         = 0x0000000D;    //Tabҳ
		public static final int eWidgetType_Layer          = 0x0000000E;    //ͼ
		public static final int eWidgetType_PickerView     = 0x0000000F;    //PickerView(androidiphoneƽ̨)
		public static final int eWidgetType_ActionSheet    = 0x00000010;    //ActionSheet(androidiphoneƽ̨) 
		public static final int eWidgetType_WebView        = 0x00000011;    //WebView(androidiphoneƽ̨)
		public static final int eWidgetType_PageControl    = 0x00000012;    //PageControl(androidiphoneƽ̨)
		public static final int eWidgetType_MessageBox     = 0x00000013;    //Ի
		public static final int eWidgetType_Mode           = 0x00000014;    //ģʽ
		public static final int eWidgetType_MapView        = 0x00000015;    //ͼؼ
		public static final int eWidgetType_NavigatorBar   = 0x00000016;    //ؼ(iphoneƽ̨) (2012.07.31)
		public static final int eWidgetType_Custom         = 0x00000017;    //ûԶؼ             (2012.07.31)
		public static final int eWidgetType_Slider         = 0x00000018;    ////slider(winceƽ̨
		public static final int eWidgetType_VarLabel       = 0x00000019;    //ɱ䱳ı(Iphoneƽ̨)
		public static final int eWidgetType_ImageList	   = 0x0000001A;	//ImageListؼ
		public static final int eWidgetType_ListItem       = 0x0000001B;    //б
		public static final int eWidgetType_Marquee        = 0x0000001C;    //ƿؼ
		public static final int eWidgetType_Numbers		   = 0x0000001D;    //ǰĿؼ͸

	};
}
